searchData={"content_type":"text/markdown","items":[{"doc":"Provides an interface which dispatches the function to the right adapter.","ref":"AnyHttp.html","title":"AnyHttp","type":"module"},{"doc":"Defines in your application the following configuration depending of the adapter you choose:\n\n    config :any_http, :client_adapter, AnyHttp.Adapters.Req","ref":"AnyHttp.html#module-configuration","title":"Configuration - AnyHttp","type":"module"},{"doc":"Makes a DELETE request to the given URL.","ref":"AnyHttp.html#delete/4","title":"AnyHttp.delete/4","type":"function"},{"doc":"Makes a GET request to the given URL.","ref":"AnyHttp.html#get/4","title":"AnyHttp.get/4","type":"function"},{"doc":"Makes a HEAD request to the given URL.","ref":"AnyHttp.html#head/3","title":"AnyHttp.head/3","type":"function"},{"doc":"Makes a PATCH request to the given URL.","ref":"AnyHttp.html#patch/4","title":"AnyHttp.patch/4","type":"function"},{"doc":"Makes a POST request to the given URL.","ref":"AnyHttp.html#post/4","title":"AnyHttp.post/4","type":"function"},{"doc":"Makes a PUT request to the given URL.","ref":"AnyHttp.html#put/4","title":"AnyHttp.put/4","type":"function"},{"doc":"","ref":"AnyHttp.html#request/5","title":"AnyHttp.request/5","type":"function"},{"doc":"","ref":"AnyHttp.html#t:adapter_opts/0","title":"AnyHttp.adapter_opts/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:body/0","title":"AnyHttp.body/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:headers/0","title":"AnyHttp.headers/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:method/0","title":"AnyHttp.method/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:response/0","title":"AnyHttp.response/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:url/0","title":"AnyHttp.url/0","type":"type"},{"doc":"Defines the behaviour for the HTTP adapters to implement.","ref":"AnyHttp.Client.html","title":"AnyHttp.Client","type":"behaviour"},{"doc":"","ref":"AnyHttp.Client.html#c:request/5","title":"AnyHttp.Client.request/5","type":"callback"},{"doc":"Defines a generic struct to encapsulate a HTTP response.","ref":"AnyHttp.Response.html","title":"AnyHttp.Response","type":"module"},{"doc":"","ref":"AnyHttp.Response.html#t:body/0","title":"AnyHttp.Response.body/0","type":"type"},{"doc":"","ref":"AnyHttp.Response.html#t:headers/0","title":"AnyHttp.Response.headers/0","type":"type"},{"doc":"","ref":"AnyHttp.Response.html#t:status/0","title":"AnyHttp.Response.status/0","type":"type"},{"doc":"","ref":"AnyHttp.Response.html#t:t/0","title":"AnyHttp.Response.t/0","type":"type"},{"doc":"Provides some functions which can be used with `AnyHttp` library.","ref":"AnyHttp.Utils.html","title":"AnyHttp.Utils","type":"module"},{"doc":"Converts a RFC1123 value into a `NaiveDateTime`.\n\nRaises a `ArgumentError` exception if the value is not a valid datetime.","ref":"AnyHttp.Utils.html#from_rfc1123_date!/1","title":"AnyHttp.Utils.from_rfc1123_date!/1","type":"function"},{"doc":"iex> AnyHttp.Utils.from_rfc1123_date!(\"Thu, 07 Dec 2023 18:06:28 GMT\")\n    ~N[2023-12-07 18:06:28]\n\n    iex> AnyHttp.Utils.from_rfc1123_date!(~c\"Thu, 07 Dec 2023 18:06:28 GMT\")\n    ~N[2023-12-07 18:06:28]\n\n    iex> AnyHttp.Utils.from_rfc1123_date!(~c\"Thu, 99 Dec 2023 18:06:28 GMT\")\n    ** (ArgumentError) cannot convert {{2023, 12, 99}, {18, 6, 28}} to naive datetime, reason: :invalid_date","ref":"AnyHttp.Utils.html#from_rfc1123_date!/1-examples","title":"Examples - AnyHttp.Utils.from_rfc1123_date!/1","type":"function"},{"doc":"Converts a `NaiveDateTime` into a valid RFC1123 value (mostly used in HTTP headers).\n\nIt accepts a second argument to define if the return value should be a `string` or a `charlist`.\n\n**Note:** The implementation relies on `:httpd_util` from Erlang but Erlang converts the value\ninto local datetime which makes the `to => from => to` inconsistent. This implementation to keep\nthe same timezone.","ref":"AnyHttp.Utils.html#to_rfc1123_date/2","title":"AnyHttp.Utils.to_rfc1123_date/2","type":"function"},{"doc":"iex> AnyHttp.Utils.to_rfc1123_date(~N[2023-12-07 18:06:28.313171])\n    \"Thu, 07 Dec 2023 18:06:28 GMT\"\n\n    iex> AnyHttp.Utils.to_rfc1123_date(~N[2023-12-07 18:06:28.313171], :binary)\n    \"Thu, 07 Dec 2023 18:06:28 GMT\"\n\n    iex> AnyHttp.Utils.to_rfc1123_date(~N[2023-12-07 18:06:28.313171], :charlist)\n    ~c\"Thu, 07 Dec 2023 18:06:28 GMT\"","ref":"AnyHttp.Utils.html#to_rfc1123_date/2-examples","title":"Examples - AnyHttp.Utils.to_rfc1123_date/2","type":"function"},{"doc":"Defines the adapter for the `hackney` library.","ref":"AnyHttp.Adapters.Hackney.html","title":"AnyHttp.Adapters.Hackney","type":"module"},{"doc":"Defines the adapter for the `:httpc` Erlang module.","ref":"AnyHttp.Adapters.Httpc.html","title":"AnyHttp.Adapters.Httpc","type":"module"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:body/0","title":"AnyHttp.Adapters.Httpc.body/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:content_type/0","title":"AnyHttp.Adapters.Httpc.content_type/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:header/0","title":"AnyHttp.Adapters.Httpc.header/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:headers/0","title":"AnyHttp.Adapters.Httpc.headers/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:http_version/0","title":"AnyHttp.Adapters.Httpc.http_version/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:httpc_error/0","title":"AnyHttp.Adapters.Httpc.httpc_error/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:httpc_response/0","title":"AnyHttp.Adapters.Httpc.httpc_response/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:status_code/0","title":"AnyHttp.Adapters.Httpc.status_code/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:status_line/0","title":"AnyHttp.Adapters.Httpc.status_line/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:url/0","title":"AnyHttp.Adapters.Httpc.url/0","type":"type"},{"doc":"Defines the adapter for the `req` library.","ref":"AnyHttp.Adapters.Req.html","title":"AnyHttp.Adapters.Req","type":"module"},{"doc":"","ref":"AnyHttp.Adapters.Req.html#t:request/0","title":"AnyHttp.Adapters.Req.request/0","type":"type"},{"doc":"","ref":"AnyHttp.Error.html","title":"AnyHttp.Error","type":"exception"},{"doc":"","ref":"AnyHttp.Error.html#t:t/0","title":"AnyHttp.Error.t/0","type":"type"},{"doc":"","ref":"AnyHttp.Error.html#t:type/0","title":"AnyHttp.Error.type/0","type":"type"},{"doc":"# Any HTTP\n\nElixir library which wraps the main HTTP libraries. It allows the final project to decide which\nHTTP library they want to use and provide an unified interface.\n\n[Documentation](https://hexdocs.pm/any_http)","ref":"readme.html","title":"Any HTTP","type":"extras"},{"doc":"```elixir\ndef deps do\n  [\n    {:any_http, \"~> 0.6\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Any HTTP","type":"extras"},{"doc":"### [:httpc](https://www.erlang.org/doc/man/httpc.html)\n\n`:httpc` is already part of your application because it's part of Erlang.\n\nChange your configuration to declare Req as your adapter:\n```elixir\nconfig :any_http, client_adapter: AnyHttp.Adapters.Httpc\n\n# You can provide default options to the adapter.\nconfig :any_http, httpc_default_opts: []\n```\n\n### [Req](https://hexdocs.pm/req)\n\nAdd Req to your `mix.exs` file:\n```elixir\ndef deps do\n  [\n    {:req, \"~> 0.4\"}\n  ]\nend\n```\n\nChange your configuration to declare Req as your adapter:\n```elixir\nconfig :any_http, client_adapter: AnyHttp.Adapters.Req\n\n# You can provide default options to the adapter.\nconfig :any_http, req_default_opts: []\n```\n\n### [:hackney](https://hexdocs.pm/hackney/)\n\nAdd Req to your `mix.exs` file:\n```elixir\ndef deps do\n  [\n    {:hackney, \"~> 1.20\"}\n  ]\nend\n```\n\nChange your configuration to declare Req as your adapter:\n```elixir\nconfig :any_http, client_adapter: AnyHttp.Adapters.Hackney\n\n# You can provide default options to the adapter.\nconfig :any_http, hackney_default_opts: []\n```","ref":"readme.html#configuration","title":"Configuration - Any HTTP","type":"extras"},{"doc":"Just call the `AnyHttp` module to interact with HTTP:\n\n```elixir\nAnyHttp.post(\n  # Provide the URL as a string or an URI\n  \"https://my_server/api\",\n  # Provide the HTTP headers as map or list of tuple, put nil if none\n  %{\"content-type\" => \"application/json\"},\n  # Provide the body, put nil if none\n  ~s<{\"hello\": \"world\"}>,\n  # Provide the adapter options, can be ommited\n  receive_timeout: :timer.seconds(5)\n)\n```\n\nThe result will look like:\n\n```elixir\n{:ok,\n  %AnyHttp.Response{\n    status: 201,\n    headers: %{\"content-type\" => [\"application/json\"]},\n    body: \"{\\\"bye\\\":\\\"world\\\"}\"\n  }\n}\n```","ref":"readme.html#usage","title":"Usage - Any HTTP","type":"extras"},{"doc":"# Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-6-3-2024-04-01","title":"v0.6.3 (2024-04-01) - Changelog","type":"extras"},{"doc":"* Updated dependencies","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-6-2-2024-03-08","title":"v0.6.2 (2024-03-08) - Changelog","type":"extras"},{"doc":"* Fixed a warning when compiling Req when version is greater than `0.4.12`.\n  * Updated dependencies","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-6-1-2023-12-28","title":"v0.6.1 (2023-12-28) - Changelog","type":"extras"},{"doc":"* Removed an option from the package preventing Dialyzer to work properly when it's used as dependency","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-6-0-2023-12-20","title":"v0.6.0 (2023-12-20) - Changelog","type":"extras"},{"doc":"* Allowed to provide default options by providing the configuration for:\n    * :httpc: `:httpc_default_opts`\n    * Hackney: `:hackney_default_opts`\n    * Req: `:req_default_opts`\n\n#","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"* Fixed an issue caused by OTP 24 and `:public_key`, introduced `:tls_certificate_check`","ref":"changelog.html#bug-fixes","title":"Bug fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-5-0-2023-12-14","title":"v0.5.0 (2023-12-14) - Changelog","type":"extras"},{"doc":"* Moved the functions `to_rfc1123_date/1`, `to_rfc1123_date/2` and `from_rfc1123_date!/1` from\n  the module `AnyHttp` to `AnyHttp.Utils`.","ref":"changelog.html#breaking-changes","title":"BREAKING CHANGES - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-4-1-2023-12-09","title":"v0.4.1 (2023-12-09) - Changelog","type":"extras"},{"doc":"* Added test to the adapter `:httpc`\n  * Reformated the `CHANGELOG.md`\n  * Improved documentation\n\n#","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"* Improved the internal headers management for `httpc`\n  * Added an exception `ArgumentError` if body is present when doing `:get` request","ref":"changelog.html#bug-fixes","title":"Bug fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-4-0-2023-12-09","title":"v0.4.0 (2023-12-09) - Changelog","type":"extras"},{"doc":"* Added the adapter for `:hackney`\n  * Added URL scheme validation\n\n#","ref":"changelog.html#new-features","title":"New features - Changelog","type":"extras"},{"doc":"* Renamed the error type from `socket_closed` to `conn_refused`","ref":"changelog.html#breaking-changes","title":"BREAKING CHANGES - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-3-2-2023-12-09","title":"v0.3.2 (2023-12-09) - Changelog","type":"extras"},{"doc":"* Fixed an issue related to `to_rfc1123_date/1` which was converting dates to local time","ref":"changelog.html#bug-fixes","title":"Bug fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-3-1-2023-12-08","title":"v0.3.1 (2023-12-08) - Changelog","type":"extras"},{"doc":"* Added the functions `to_rfc1123_date/1` and `to_rfc1123_date/2` to the module `AnyHttp` to\n  convert from a `NaiveDateTime` struct to a valid date as RFC1123 value\n  * Added a function `from_rfc1123_date!/1` to the module `AnyHttp` to convert from a RFC1123 date\n  to a `NaiveDateTime` struct\n\n#","ref":"changelog.html#new-features","title":"New features - Changelog","type":"extras"},{"doc":"* Unified the errors between the adapters\n    * Added support for:\n      * `nxdomain`: Non-existing domain\n      * `socket_closed`: When the server responded with an error (i.e. a port isn't opened)\n      * `unknown_ca`: Unable to verificate TLS certificate\n      * `unknown_error`: Used when error not supported","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-3-0-2023-12-08","title":"v0.3.0 (2023-12-08) - Changelog","type":"extras"},{"doc":"* Added an exception module `Error`\n\n#","ref":"changelog.html#new-features","title":"New features - Changelog","type":"extras"},{"doc":"* Used `AnyHttp.Adapters.Httpc` as default adapter\n  * Added specific Elixir type for `headers` depending of Elixir version","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-0-2023-12-07","title":"v0.2.0 (2023-12-07) - Changelog","type":"extras"},{"doc":"* Added the adapter `:httpc`\n\n#","ref":"changelog.html#new-features","title":"New features - Changelog","type":"extras"},{"doc":"* Set Elixir to the version 1.13.4\n  * Set Erlang to the version 25.3.2.7\n  * Setup Github actions to use `.tool-versions` file\n  * Refactored the module `AnyHttp` and its type specificiations\n\n#","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"* Ensured the application `Req` is started during `dev` and `test`","ref":"changelog.html#bug-fixes","title":"Bug fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-1-1-2022-07-22","title":"v0.1.1 (2022-07-22) - Changelog","type":"extras"},{"doc":"* Added some documentations","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-1-0-2022-07-22","title":"v0.1.0 (2022-07-22) - Changelog","type":"extras"},{"doc":"* Added a single interface to make HTTP calls\n  * Implemented `Req` as adapter.","ref":"changelog.html#new-features","title":"New features - Changelog","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}